<?
#########################################################################################################
#													#
#    Copyright (c) 2006 Ciaran Farrell <ciaranfarrell@babelworx.net>					#
#    This file is free software; you can redistribute it and/or						#
#    modify it under the terms of the GNU Lesser General Public						#
#    License as published by the Free Software Foundation; either					#
#    version 2.1 of the License, or (at your option) any later version.					#
#													#
#    This file is distributed in the hope that it will be useful,					#
#    but WITHOUT ANY WARRANTY; without even the implied warranty of					#
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU					#
#    Lesser General Public License for more details.							#
#													#
#    You should have received a copy of the GNU Lesser General Public					#
#    License along with this file; if not, write to the Free Software					#
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA				#
#													#	
#########################################################################################################

class oopCal{
	var $year;
	var $month;
	var $tableBG;
	var $tableBorder;
	var $cellspacing;
	var $cellpadding;
	var $cellWidth;
	var $cellHeight;
	var $fontColor;
	var $todayColor;
	var $headerBG;
	var $headerFont;
	var $weekendColor;
	var $emptyColor;
	var $emptyFill;
	var $emptyFont;
	var $dbaseSwitch;
	var $dbaseConn;
	var $pastEvent;
	var $todayEvent;
	var $futureEvent;
	var $useOverlib;
	var $overLibBG;
	var $overLibCapBG;
	var $overLibBorder;
	var $showHeader;
	var $headerContent;
	var $overLibSticky;
	var $overLibAlign;
	var $overLibTimeOut;
	var $jscriptParams;
	var $extParams;
	
	function defineCal($calDef){
		
		/* return an error if we weren't sent a valid array */
		if(!is_array($calDef) || empty($calDef)){
			$this->definedCalendar = "you must send an array to this function";
		}else{
		
		/*  first extract the variables from the array */
		$this->year = $calDef[year];
		$this->month = $calDef[month];
		$this->tableBG = $calDef[tableBG];
		$this->tableBorder = $calDef[tableBorder];
		$this->cellspacing = $calDef[cellspacing];
		$this->cellpadding = $calDef[cellpadding];
		$this->cellWidth = $calDef[cellWidth];
		$this->cellHeight = $calDef[cellHeight];
		$this->fontColor = $calDef[fontColor];
		$this->todayColor = $calDef[todayColor];
		$this->headerBG = $calDef[headerBG];
		$this->headerFont = $calDef[headerFont];
		$this->weekendColor = $calDef[weekendColor];
		$this->emptyColor = $calDef[emptyColor];
		$this->emptyFill = $calDef[emptyFill];
		$this->emptyFont = $calDef[emptyFont];
		$this->dbaseSwitch = $calDef[dbaseSwitch];
		$this->dbaseConn = $calDef[dbaseConn];
		$this->pastEvent = $calDef[pastEvent];
		$this->todayEvent = $calDef[todayEvent];
		$this->futureEvent = $calDef[futureEvent];
		$this->useOverlib = $calDef[useOverlib];
		$this->overLibBG = $calDef[overLibBG];
		$this->overLibCapBG = $calDef[overLibCapBG];
		$this->overLibBorder = $calDef[overLibBorder];
		$this->showHeader = $calDef[showHeader];
		$this->headerContent = $calDef[headerContent];
		$this->overLibSticky = $calDef[overLibSticky];
		$this->overLibAlign = $calDef[overLibAlign];
		$this->overLibTimeOut = $calDef[overLibTimeOut];
		$this->jscriptParams = $calDef[jscriptParams];
		$this->extParams = $calDef[extParams];
		
		/* create an array for the overlib events */
		$this->overLibEvents = array();
		$this->overLibEvents[useOverLib] = $this->useOverlib;
		$this->overLibEvents[overLibBG] = $this->overLibBG;
		$this->overLibEvents[overLibCapBG] = $this->overLibCapBG;
		$this->overLibEvents[overLibBorder] = $this->overLibBorder;
		$this->overLibEvents[showHeader] = $this->showHeader;
		$this->overLibEvents[headerContent] = $this->headerContent;
		$this->overLibEvents[overLibSticky] = $this->overLibSticky;
		$this->overLibEvents[overLibAlign] = $this->overLibAlign;
		$this->overLibEvents[overLibTimeOut] = $this->overLibTimeOut;
		/* how many days in this month */
		function days_in_month($month, $year){ // function found on php.net 
 			return $month == 2 ? ($year % 4 ? 28 : ($year % 100 ? 29 : ($year % 400 ? 28 : 29))) : (($month - 1) % 7 % 2 ? 30 : 31); 
		}
		
		/* A function to shorten text to make it easier to fit on the page. Written by Ciaran Farrell on 2005-09-15 */
		function chopText($text, $chars){
			preg_match("/(.{0,$chars}\b)/s",$text, $output);
			return $output[0].'...';
		}
		
		$this -> daysCount = days_in_month($this->month,$this->year);		
		
		/* create an associative array with the date (day of month) as key */
		$assocDays = array();
		for($i="1";$i<=$this->daysCount;$i++){
			$assocDays[$i] = date("D",strtotime("{$this->year}-{$this->month}-{$i}"));
		}
		$this->assoc = $assocDays;
		
		
		/* Access the database table defined by us (i.e. not particularly customizable */
		
			if($this->dbaseSwitch == "on"){

				/* Figure out the first and the last date in the month in mysql compat syntax*/
					$firstDay = "{$this->year}-{$this->month}-01 00:00:00";
					$lastDay = "{$this->year}-{$this->month}-{$this->daysCount} 23:59:59";
				
				/* include external file in which the dbase connection work is done */
				include($this->dbaseConn);
				
				/* query the dbase events table for any events occurring this month */
				$queryMonth = "SELECT * FROM events WHERE (eventDate >= '{$firstDay}' AND eventDate <= '{$lastDay}') ORDER BY eventDate ASC";

				$execQuery = mysql_query($queryMonth) or die (mysql_error());
				
				/* Loop through the results for this month */
				while($eventsRec = mysql_fetch_object($execQuery)){
					$indEvent[eventID] = $eventsRec -> eventID;
					$indEvent[eventDesc] = $eventsRec -> eventDesc;
					$indEvent[eventDate] = $eventsRec -> eventDate;
					$indEvent[eventURL] = $eventsRec -> eventURL;
					$indEvent[eventOrganiser] = $eventsRec -> eventOrganiser;
					$indEvent[eventStart] = $eventsRec -> eventStart;
					$indEvent[eventFinish] = $eventsRec -> eventFinish;
					$indEvent[eventPlace] = $eventsRec -> eventPlace;
					$indEvent[eventCost] = $eventsRec -> eventCost;
					$indEvent[day_of_month] = date("j",strtotime($indEvent[eventDate]));
				/* Now we have a multidimensional array with all the events this month */		
					$events[] = $indEvent;
					unset($indEvent);	
				}

				/* If the events variable is empty assign it any old value */
				if(empty($events)){
					$events = "empty"; // note, not an array
				}
			
		}
	
		
		/* A function to check a given date and to return stlyed output if an event occurs on that day */
		function checkEvent($date, $month,$year,$fontColor, $todayColor, $eventColor, $weekendColor, $tableColor,$pastEvent, $todayEvent, $futureEvent,$assocDays, $cellHeight, $cellWidth, $events, $overLibEvents, $openLinkEvent, $openLinkBehaviour){
			for($i="0";$i<count($events);$i++){
				$myEvent = $events[$i];
			if($myEvent[day_of_month] == $date){ // if the event takes place on this day (i.e. $i)
				$gather_conn_eff[$date] = $date; // add the event to an array of events this month
				}
			}
			
			if($overLibEvents[useOverLib] == "yes"){
				$useOverlib = "yes";
				$overLibBG = $overLibEvents[overLibBG];
				$overLibCapBG = $overLibEvents[overLibCapBG];
				$overLibBorder = $overLibEvents[overLibBorder];
				$overLibShowHeader = $overLibEvents[showHeader];
				$overLibHeaderContents = $overLibEvents[headerContent];
				$overLibTimeOut = $overLibEvents[overLibTimeOut];
				if(!empty($events) && is_array($events)){
					foreach($events as $key => $value){
						// The actual content of the pane
						if(date("j",strtotime($value[eventDate])) == $date){
						$overLibPaneContent = chopText($value[eventDesc], "55");
						}
						
						// what is the reference url for the event?
						if(date("j",strtotime($value[eventDate])) == $date){
						$eventLink = $value[eventURL];
						}
						
						// What should we display as a caption
						if($overLibShowHeader == "yes"){ 
							if($overLibHeaderContents == "dateTime" && date("j",strtotime($value[eventDate])) == $date){
								$startTime = date("H:i",strtotime($value[eventStart]));
								$endTime = date("H:i",strtotime($value[eventFinish]));
								$caption = "CAPTION, '{$startTime} - {$endTime}',";
							
								}
							}else{
								$caption = "";
								}
						}
				}
				$overLibSticky = $overLibEvents[overLibSticky];
				$overLibAlign = $overLibEvents[overLibAlign];
					
					// Do we want to use sticky panes?
					if($overLibSticky == "yes"){
						$sticky = "STICKY,";
					}else{
						$sticky = "";
					}
					
					// How to align the pane with respect to the mouse pointer
					if($overLibAlign == "right"){
						$align = "RIGHT";
					}
					elseif($overLibAlign == "center"){
						$align = "CENTER";
					}
					elseif($overLibAlign == "left"){
						$align = "LEFT";
					}
					else{
						$align = "RIGHT"; // Defaults to right
					}
					
					
					// What is the colour of the pane (I call it bgColor, the actual overLib term is FGCOLOR
					if($overLibBG != "default"){
						$bgColor = "FGCOLOR, '{$overLibBG}',";
					}else{
						$bgColor = "";
					}
					
					// What is the colour of the text in the caption
					if($overLibCapBG != "default"){
						$capColor = "CAPCOLOR, '{$overLibCapBG}',";
					}else{
						$capColor = "";
					}
					
					
					// What is the colour of the border and header
					if($overLibBorder != "default"){
						$borderColor = "BGCOLOR, '{$overLibBorder}',";
					}else{
						$borderColor = "";
					}
					
					// What is the timeout before destroying popup?
					if($overLibTimeOut == ""){
						$overLibTimeOut = "TIMEOUT, '0',";
					}else{
						$overLibTimeOut = "TIMEOUT, '{$overLibTimeOut}',";
					}
					
			}else{
				$useOverlib = "no";
			}
			
			

			$events = count($gather_conn_eff);

			if($assocDays[$date] == "Sat" || $assocDays[$date] == "Sun"){
				$cellBackground = $weekendColor;
			}else{
				$cellBackground = $tableColor;
			}
			
			// How does the user want the links to open?
			if($openLinkEvent == "window.location"){ // different formatting needed for window.location
				$buildLinkRef = "a href=\"javascript:window.location='{$eventLink}' {$openLinkBehaviour}\""; // the javascript parameters for the ahref
			}else{
			$buildLinkRef = "a href=\"javascript:{$openLinkEvent}('{$eventLink}' {$openLinkBehaviour})\""; // the javascript parameters for the ahref
			}
			// Now add any additional attributes to the behaviour ($openLinkBehavour)
			
			# a href=\"{$myEvent[eventURL]}\"
			
			#if(date("Y-m-d",time())>date("Y-m-d",strtotime($myEvent[eventDate]))) { // Event occurred in the past
			if(time()>strtotime($myEvent[eventDate])) { // Event occurred in the past
				if($useOverlib != "yes"){ // if we are not using overlib
				$eventLink = "<{$buildLinkRef} style=\"text-decoration:none;color:{$pastEvent}\">{$date}</a>";
				}else{ // if we are using overlib to display mouseOver event information (see README for other changes which have to be made beforehand)
				$eventLink = "<{$buildLinkRef} onMouseOver=\"return overlib('{$overLibPaneContent}', {$sticky} {$caption} {$bgColor} {$overLibTimeOut} {$capColor} {$borderColor} {$align});\" onmouseout=\"return nd();\" style=\"text-decoration:none;color:{$pastEvent}\">{$date}</a>";
				}
			}
			elseif(date("Y-m-d",time()) == date("Y-m-d",strtotime($myEvent[eventDate]))) { // Event is today
				
				if($useOverlib != "yes"){ // if we are not using overlib
				$eventLink = "<{$buildLinkRef} style=\"text-decoration:none;color:{$todayEvent}\">{$date}</a>";
				}else{ // if we are using overlib to display mouseOver event information (see README for other changes which have to be made beforehand)
				$eventLink = "<{$buildLinkRef} onMouseOver=\"return overlib('{$overLibPaneContent}', {$sticky} {$caption} {$bgColor} {$overLibTimeOut} {$capColor} {$borderColor} {$align});\" onmouseout=\"return nd();\" style=\"text-decoration:none;color:{$todayEvent}\">{$date}</a>";
				}
			}
			
			#elseif(date("j",time())<date("Y-m-d",strtotime($myEvent[eventDate]))){ // Event is some time in the future
			elseif(time()<strtotime($myEvent[eventDate])) { // Event is some time in the future
				
				if($useOverlib != "yes"){ // if we are not using overlib
				$eventLink = "<{$buildLinkRef} style=\"text-decoration:none;color:{$futureEvent}\">{$date}</a>";
				}else{ // if we are using overlib to display mouseOver event information (see README for other changes which have to be made beforehand)
				$eventLink = "<{$buildLinkRef} onMouseOver=\"return overlib('{$overLibPaneContent}', {$sticky} {$caption} {$bgColor} {$overLibTimeOut} {$capColor} {$borderColor} {$align});\" onmouseout=\"return nd();\" style=\"text-decoration:none;color:{$futureEvent}\">{$date}</a>";
				}
			}
		
			/* See if $i is today - if so mark it accordingly */
			if($date == date("j",time()) && $month == date("n",time()) && $year == date("Y",time()) && !empty($events)){ // if there is an event today
			 $html = "<td align=\"center\" height=\"{$cellHeight}\" width=\"{$cellWidth}\" style=\"background:yellow;border-style:solid;border-width:1px\">{$eventLink}</td>";	
			}
			elseif($date == date("j",time()) && $month == date("n",time()) && $year == date("Y",time())){ // if there is no event today
			 $html = "<td align=\"center\" height=\"{$cellHeight}\" width=\"{$cellWidth}\" style=\"border-style:solid;border-width:1px\"><span style=\"color:{$todayColor}\">{$date}</span></td>";	
			}
			
			/* PUT THE ELSEIF CONTAINING THE EVENT CHECKER HERE */	
			elseif(!empty($events)){ // if an event occurs on this day
			$html = "<td align=\"center\" height=\"{$cellHeight}\" width=\"{$cellWidth}\">{$eventLink}</td>";	
			}
			else{	// if no event on this day
			 $html = "<td align=\"center\" height=\"{$cellHeight}\" width=\"{$cellWidth}\" style=\"background-color:{$cellBackground};\">{$date}</td>";
			}
			
			
			return($html);
		}
		
		/* if any multiple values are needed define them here first */
		$table_width = $this->cellWidth*7;
		
		/* create a bar at the top to hold back arrow, current month, year and forward arrow */
		$monthNames = array("January","February","March","April","May","June","July","August","September","October","November","December");
		$numericMonth = $this->month-1; // array starts with 0 so we have to sub 1 from sent month
		$presentMonth = $monthNames[$numericMonth];
		$parseYear = $this->year;
		$lastYear = $parseYear-1;
		$nextYear = $parseYear+1;
		switch($this->month){
			case "1":
				$previousMonth = "12";
				$nextMonth = "2";
				$linkBack = "<a href=\"{$this->scriptLocation}?year={$lastYear}&month={$previousMonth}\" style=\"text-decoration:none\"><span style=\"color:{$this->headerFont}\"><</span></span></a>";
				$linkForward = "<a href=\"{$this->scriptLocation}?year={$parseYear}&month={$nextMonth}\" style=\"text-decoration:none\"><span style=\"color:{$this->headerFont}\">></span></span></a>";
			break;
			case "12":
				$previousMonth = "11";
				$nextMonth = "1";
				$linkBack = "<a href=\"{$this->scriptLocation}?year={$parseYear}&month={$previousMonth}\" style=\"text-decoration:none\"><span style=\"color:{$this->headerFont}\"><</span></span></a>";
				$linkForward = "<a href=\"{$this->scriptLocation}?year={$nextYear}&month={$nextMonth}\" style=\"text-decoration:none\"><span style=\"color:{$this->headerFont}\">></span></span></a>";
				
			break;
			default:
				$previousMonth = $this->month-1;
				$nextMonth = $this->month+1;
				$linkBack = "<a href=\"{$this->scriptLocation}?year={$parseYear}&month={$previousMonth}\" style=\"text-decoration:none\"><span style=\"color:{$this->headerFont};text-decoration:none;\"><</span></span></a>";
				$linkForward = "<a href=\"{$this->scriptLocation}?year={$parseYear}&month={$nextMonth}\" style=\"text-decoration:none\"><span style=\"color:{$this->headerFont}\">></span></span></a>";
		}
		
		
		
		
		
		$bar = "<table width=\"$table_width\" border=\"{$this->tableBorder}\" bgcolor=\"{$this->headerBG}\" cellspacing=\"{$this->cellspacing}\" cellpadding=\"{$this->cellpadding}\"><tr><td width=\"15%\" align=\"left\">{$linkBack}</td><td width=\"70%\" align=\"center\"><span style=\"color:{$this->headerFont}\">{$presentMonth} {$this->year}</span></td><td width=\"15%\" align=\"right\">{$linkForward}</td></tr></table>";
		
		/* create an standard array for weekdays with week starting on Monday (not Sunday as per Solaris)*/
		$weekDays = array("Mon","Tue","Wed","Thu","Fri","Sat","Sun"); // deliberately shortened to save space
		/* commence building the calendar */
		$tableDef = "<table width=\"{$table_width}\" border=\"{$this->tableBorder}\" cellspacing=\"{$this->cellspacing}\" cellpadding=\"{$this->cellpadding}\" bgcolor=\"{$this->tableBG}\"><span style=\"color:{$this->fontColor}\">
					<tr>";
					
		
		for($i="0";$i<7;$i++){
			$topCell[] = "<td width=\"{$this->cell_width}\" align=\"center\">{$weekDays[$i]}</td>";
		}
		
		/* create a row of cells starting with monday and running through till sunday - or use implode */
		$tableSplit = implode($topCell)."</tr><tr>";
		
		/* first row is critical in row as we don't know where to begin - we have to create an offset */
		$firstDay = $assocDays[1]; // first day of month as shortened weekday
		switch($firstDay){
			case "Mon":
				$offSet = "1";
			break;
			case "Tue":
				$offSet = "2";
			break;
			case "Wed":
				$offSet = "3";
			break;
			case "Thu":
				$offSet = "4";
			break;
			case "Fri":
				$offSet = "5";
			break;
			case "Sat":
				$offSet = "6";
			break;
			case "Sun":
				$offSet = "7";
			break;
			default:
				$offSet = "1";
				
		}
	
		
		/* now print out empty cells for each day of week preceding first day in month */
		for($i="1";$i<$offSet;$i++){
			$emptyCell[] = "<td align=\"center\" height=\"{$this->cellHeight}\" width=\"{$this->cellWidth}\" bgcolor=\"{$this->emptyColor}\"><span style=\"color:{$this->emptyFont}\">{$this->emptyFill}</span></td>"; // we need a non-breaking space in the cell
		}
		
		/* max offset is 7 and if the array key is not set nothing will be printed (or use implode) */
		if(!empty($emptyCell)){
		$firstCells = implode($emptyCell);
		}
		/* there is a max of 7 possible cells -> left over are now 7-$offset */
		for($i="1";$i<(9-$offSet);$i++){
			
			$output1[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent, $assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);

		}

		$firstFill = implode($output1);
		
		/* the next row must have all cells full */
		for($i=(9-$offSet);$i<(9-$offSet)+7;$i++){
			
		$output2[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent, $assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);

		}
		$secondFill = implode($output2);
		
		/* the third row has to be full too */
		for($i=(9-$offSet)+7;$i<(9-$offSet)+14;$i++){
			
			$output3[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent, $assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);
		}
		$thirdFill = implode($output3);
		
		
		/* the fourth row has to be full too, even for no offset and February without leap year */
		for($i=(9-$offSet)+14;$i<(9-$offSet)+21;$i++){
		
			$output4[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent,$assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);
		}
		
		if(!empty($output4)){
		$fourthFill = implode($output4);
		}
		
		
		/* As of now we have to know how many days are in the month before we can finish */
		$lastCounted = (9-$offSet)+20; // The last counted (we used LESS THAN)
		$remainingDays = $this->daysCount-$lastCounted;

		/* Now take care of the last rows but only if there is more than 0 remaining days */
		if($remainingDays > "0" && $remainingDays < "8"){ // we only have a fifth row
			for($i=(9-$offSet)+21;$i<=($this->daysCount);$i++){
			
			$output5[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent, $assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);
		}
		$fifthFill = implode($output5);
		
		/* there are still possibly some remaining empty cells. they should at least get a &nbsp; */
			 // 5 rows with 7 cells is 35 total cells
			$occupied = count($output5);
			for($i=$occupied+1;$i<8;$i++){
				
				$fillRow[] = "<td align=\"center\" width=\"{$this->cellWidth}\" height=\"{$this->cellHeight}\" ><span style=\"color:{$this->emptyFont}\">{$this->emptyFill}</span></td>";
			}
			if(!empty($fillRow)){
			$expandFiller = implode($fillRow);
			}
		$lastRow = "<tr>{$fifthFill}{$expandFiller}</tr>"; // if it doesn't exist it won't be printed
		}
		
		
		
		elseif($remainingDays > "7"){ // We now have a fifth and sixth row
			for($i=(9-$offSet)+21;$i<(9-$offSet)+28;$i++){
				
			$output5[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent, $assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);
		}
		if(!empty($output5)){
		$fifthFill = implode($output5);
		}
		
		for($i=(9-$offSet)+28;$i<($this->daysCount)+1;$i++){
						
		$output6[] = checkEvent($i, $this->month,$this->year,$this->fontColor, $this->todayColor, $this->eventColor, $this->weekendColor, $this->tableBG, $this->pastEvent,$this->todayEvent,$this->futureEvent, $assocDays, $this->cellHeight, $this->cellWidth, $events, $this->overLibEvents, $this->jscriptParams, $this->extParams);
			}
		if(!empty($output6)){
		$sixthFill = implode($output6);
		}
		/* there are still possibly some remaining empty cells. they should at least get a &nbsp; */
			 // 6 rows with 7 cells is 42 total cells
			$occupied = count($output6);
			for($i=$occupied+1;$i<8;$i++){
				
				$fillRow[] = "<td align=\"center\" width=\"{$this->cellWidth}\" height=\"{$this->cellHeight}\" <span style=\"color:{$this->emptyFont}\">{$this->emptyFill}</span></td>";
			}
			if(!empty($fillRow)){
			$expandFiller = implode($fillRow);
			}
			$lastRow = "<tr>{$fifthFill}</tr><tr>{$sixthFill}{$expandFiller}</tr>"; // if it doesn't exist it won't be printed	
		}
		
			
		/* finish off the table */
		$tableFoot = "</table></span>";
		
		/* now build the table by concatenating the vars */
		$defineTable = $bar.$tableDef.$tableSplit.$firstCells.$firstFill."<tr>".$secondFill."</tr>"."<tr>".$thirdFill."</tr>"."<tr>".$fourthFill."</tr>".$lastRow.$tableFoot;

		/* now create the object def that we can access */
		$this->definedCalendar = $defineTable;
		}
	}
}


?>
