<?
	/*
		Important information!
			This demo shows how to use the overLib and ajax functionality included with the CMapp calendar
			You can change the calendar displayed by this demo easily, by changing the file calendar.config.inc
			Please read the README included in the same directory as this file for more information on how
			to use the CMapp calendar. It is very important to read the file COPYING for information on licensing
			
			To get the most up-to-date version of the CMapp Calendar, visit http://cmapp.sourceforge.net. Please
			leave a rating for the CMapp calendar at http://www.hotscripts.com/Detailed/57769.html
			
			For bug reports and/or feature requests, please e-mail the author at ciaranfarrell@babelworx.net
	*/
	
	/* include the calendar.php file */
	require("calendar.php");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
	<head>
		<title>
			..:: Demonstration of the CMapp Object Orientated Calendar ::..
		</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<!-- This must be included between the head tags if the overlib functionality is required. Please read the license for overLib!-->
		<script type="text/javascript" src="overlib/overlib.js"><!-- overLIB (c) Erik Bosrup --></script>
		<!-- This links in the jscript file which contains the ajax functionality -->
		<script src="ajax/main.js"></script>
	</head>
	<body>
		<!-- This must be included right after the body tag if the overlib functionality is required. See the README for more information! -->
		<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
		<table width="100%" cellspacing="2" cellpadding="2" border="0">
			<tr>
				<td width="25%" valign="top">
					<? 
						// Put this code anywhere on the page to display the calendar
						echo $showCal;
					?>
					<p>
					<?
						// If the logo does not display locally, just delete it
					?>
					<div align="left"><a href="http://sourceforge.net"><img src="http://sflogo.sourceforge.net/sflogo.php?group_id=148665&amp;type=5" width="210" height="62" border="0" alt="SourceForge.net Logo" /></a>
					</div>
					</p>
				</td>
				<td width="75%" valign="top">
					<strong>cmappCalendar Version 1.1</strong><br/>
					<p>
					This is a simple demonstration of what is possible with the cmappCalendar - a very fast object-orientated calendar with support for MySQL and for Eric Bosrup's overLib (optional, of course). <span style="color:#F00000">Important note:</span> if the calendar is not fast, this is most probably because the Sourceforge servers are notoriously slow. Another demo version of the calendar will be put up as soon as possible (it's now April 2006, so hopefully this will be done by May) on the http://www.babelworx.net site - which should show off how fast the calendar really is.
					</p>
					<p>
					<strong><span style="color:#F00000">Download the source:</span></strong><br/>
					There are currently two versions of the cmappCalendar available for download - cmappCalendar-1.0 and cmappCalendar-1.1 - it is highly advisable to use the latest version as there are numerous bug-fixes contained in it. Version 1.0 is only offered for download so that anyone who wants can see how the code was developed.<br/>
						<ul>Click <a href="http://cmapp.sourceforge.net/snapshot_repository/cmappCalendar-1.1.tar.gz">here</a> to download cmappCalendar-1.1</ul>
						<ul>Click <a href="http://cmapp.sourceforge.net/snapshot_repository/cmappCalendar-1.0.tar.gz">here</a> to download cmappCalendar-1.0</ul>
					</p>
					<p>
					<strong>To-Do:</strong><br/>
					There is still quite a lot of work to go into the calendar. The next big job is to get the ajax functions working reliably and well. That way, it will be possible to navigate using the calendar without having to reload the whole page (frustrating, but usually the same no matter what calendar is used). Apart from getting the ajax functions working, a GUI for entering events has to be programmed as well - I'm not sure yet, whether or not I'm going to make this log-in based, or whether users (admins) will have to integrate it with their own log-in systems - I might make it configurable.
					</p>
					<p>
					I also want to adapt the object calling function in the calendar.php script to allow for overriding the calendar.config.inc script. This will mean that I can have multiple (differently configured) objects generated from a single class file and a single configuration script (kind of the whole point of object-orientated programming :) ) and thus can display multiple different calendars on a single page.
					</p>
					<p>
					Another thing that is going to be implemented soon is a configurable system for opening the links in the calendar - for example, it should be configurable, through the calendar.config.inc script, whether the link opens in a particular frame, in a new window (using target = _blank etc) or whether a javascript behaviour should be used. Ajax makes it possible to load the link into a new div - but I'm not going to count this feature as a priority - if anyone else wants to do it, please - go ahead!
					</p>
					<p>
					<strong>Want to help?</strong><br/>
					Great! You can help out with the calendar, or, if you're feeling brave, with the CMapp Contract Management Application (the big application out of which the calendar was spun). Either way, just send me an email at ciaranfarrell at babelworx dot net (where at = @ and dot = .) and I'll send you on the developers documentation of what's done up till now.
					</p>
				</td>
			</tr>
		</table>
	</body>
</html>